#
# Sensus Consulting Ltd, Copyright 1997-1998
#
# Matt Newman <matt@sensus.org>
#
#INDEX\
proc tk++::Applet {} {}

package require tk++

proc applet {w args} {uplevel tk++::App $w $args}

class tk++::Applet {
	inherit tk++::Window

	constructor {args} {}

	public {
		method center {widget}

		itk_option define -exitmsg exitMsg ExitMsg {
This will shut down your entire application.
If you only want to close this window select
"Close" instead.

Do you wish to shut down this application?}
	}
	protected {
		method exitApp {{code 0}}
		method closeApp {{code 0}}
	}
}
body tk++::Applet::constructor {args} {
    component hull configure -highlightthickness 0

    wm protocol $itk_interior WM_DELETE_WINDOW [code $this closeApp 0]

    eval itk_initialize $args
}
body tk++::Applet::center {widget} {
    update idletasks

    set w [winfo reqwidth $itk_interior]
    set h [winfo reqheight $itk_interior]
    set sh [winfo screenheight $itk_interior] ;# display screen's height/width
    set sw [winfo screenwidth $itk_interior]
    #
    # User can request it centered with respect to root by passing in '{}'
    #
    if { $widget == "" } {
		set reqX [expr {($sw-$w)/2}]
		set reqY [expr {($sh-$h)/2}]
    } else {
		set wfudge 5      ;# wm width fudge factor
		set hfudge 20     ;# wm height fudge factor
		set widgetW [winfo width $widget]
		set widgetH [winfo height $widget]
		set reqX [expr [winfo rootx $widget]+($widgetW-($widgetW/2))-($w/2)]
		set reqY [expr [winfo rooty $widget]+($widgetH-($widgetH/2))-($h/2)]

		#
		# Adjust for errors - if too long or too tall
		#
		if { [expr $reqX+$w+$wfudge] > $sw } {
			set reqX [expr $sw-$w-$wfudge]
		}
		if { $reqX < $wfudge } {
			set reqX $wfudge
		}
		if { [expr $reqY+$h+$hfudge] > $sh } {
			set reqY [expr $sh-$h-$hfudge]
		}
		if { $reqY < $hfudge } {
			set reqY $hfudge
		}
    } 
    wm geometry $itk_interior +$reqX+$reqY
    update idletasks
}
body tk++::Applet::exitApp {{code 0}} {
    set ret [tk_messageBox -parent $itk_interior \
					-icon warning \
					-type okcancel \
					-message $itk_option(-exitmsg)]
    if {$ret != "ok"} return

    destroy .
    exit $code
}
body tk++::Applet::closeApp {{code 0}} {
    # If last child of . exit.
    set children [winfo children .]
    if {[llength $children] < 2} {
	::destroy .
	exit $code
    } else {
	::destroy [namespace tail $this]
    }
}
