#
# Sensus Consulting Ltd (C) 1997
# Matt Newman <matt@sensus.org>
#
#INDEX\
proc tk++::Scroll {} {}

package require tk++

proc scroll {w class args} {
	return [uplevel 1 tk++::Scroll $w $class $args]
}

class tk++::Scroll {
	inherit itk::Widget

	constructor {widget args} {}

	# return child frame
	public {
		method child {} {return $itk_component(child)}
	}
	protected {
		method _reconfig {{when later}}
		method _set {ax pc0 pc1}

		variable reconfig	""

		variable x,idle	""
		variable x,mode	off
		variable x,pack	""

		variable y,idle	""
		variable y,mode	off
		variable y,pack	""
	}
}

body tk++::Scroll::constructor {widget args} {

	itk_option add hull.borderwidth hull.relief

	frame $itk_interior.h -bd 0
	frame $itk_interior.w -bd 0
	frame $itk_interior.tf -bd 0
	frame $itk_interior.bf -bd 0

	itk_component add y {
		scrollbar $itk_interior.y -orient v -command "$itk_interior.child yview" -bd 0
	} {
		keep -background
	}
	itk_component add x {
		scrollbar $itk_interior.x -orient h -command "$itk_interior.child xview" -bd 0
	} {
		keep -background
	}
	itk_component add fill {
		frame $itk_interior.fill -bd 0
	} {
		keep -background
	}
	itk_component add child {
		eval $widget $itk_interior.child $args
	}
	$itk_component(child) conf \
		-xscrollcommand [code $this _set x] \
		-yscrollcommand [code $this _set y]

	pack $itk_component(child) -in $itk_interior.tf -side left -fill both -expand yes
	pack $itk_component(fill) -in $itk_interior.bf -side left 
	
	pack $itk_interior.h -side left -fill y
	pack $itk_interior.bf -side bottom -fill x
	pack $itk_interior.w -side bottom -fill x
	pack $itk_interior.tf -side left -fill both -expand yes

	bind $itk_component(x) <Configure> [code $this _reconfig]
	bind $itk_component(y) <Configure> [code $this _reconfig]

	set x,pack "-in $itk_interior.bf -before $itk_component(fill) \
					-anchor nw -side left -fill x -expand yes"
	set y,pack "-in $itk_interior.tf -before $itk_component(child) \
					-anchor ne -side right -fill y"

	itk_initialize
}
body tk++::Scroll::_reconfig {{when later}} {
	if {$when == "later"} {
		if {$reconfig == ""} {
			set reconfig [after idle [code $this _reconfig now]]
		}
		return
	}
	set reconfig	""

	$itk_component(fill) conf -width [winfo reqwidth $itk_component(y)] -height 1
}
#
# This code can flip-flop
#
body tk++::Scroll::_set {ax pc0 pc1} {
	$itk_component($ax) set $pc0 $pc1

	if {[set $ax,mode]=="off"} {
		if {$pc0 != 0 || $pc1 != 1} {
			eval pack $itk_component($ax) [set $ax,pack]
			set $ax,mode on
		}
	} else {
		if {$pc0 == 0 && $pc1 == 1} {
			pack forget $itk_component($ax)
			set $ax,mode off
		}
	}
}
