#
# Sensus Consulting Ltd (c) 1997
# Matt Newman <matt@sensus.org>
# Experimental
#
#INDEX\
proc tk++::Sheet {} {}

package require tk++
package require Tktable

option add *Sheet.background white widgetDefault
option add *Sheet.width 0 widgetDefault
option add *Sheet.height 0 widgetDefault
option add *Sheet.cursor crosshair widgetDefault

proc sheet {w args} {uplevel 1 tk++::Sheet $w $args}

class tk++::Sheet 
	inherit itk::Widget

	constructor {args} {}

	itk_option define -variable variable Variable "" {_reconfig $this}
	itk_option define -rows rows Rows "" 	{_reconfig $this}
	itk_option define -cols cols Cols "" 	{_reconfig $this}

	private method _fetch {r c}
	private method _reconfig {}
}
body tk++::Sheet::constructor {args} {

	label $itk_interior.tmp
	itk_component add scroll {
		scroll $itk_interior.s table -font [$itk_interior.tmp cget -font] \
			-highlightthickness 0 \
			-rows 0 -cols 0 \
			-titlerows 1 -titlecols 0 \
			-roworigin -1 -colorigin 0 \
			-flashmode 0 -cache 1 -batchmode 1 -drawmode fast \
			-borderwidth 1 -anchor w -relief sunken -colwidth 15 \
			-state disabled -selectmode extended \
			-command [code _fetch $this %r %c]
	}
	itk_component add table {
		$itk_component(scroll) child
	} {
		keep -highlightthickness -background
		keep -titlerows -titlecols -roworigin -colorigin
		keep -width -height -cursor
		keep -anchor -colwidth -state -selectmode
	}
	$itk_component(table) tag conf title -relief raised -bg SystemButtonFace -fg black
	#bind $w.child <Motion> "break"

	::destroy $itk_interior.tmp

	pack $itk_component(scroll) -fill both -expand yes

	eval itk_initialize $args
}

body tk++::Sheet::_fetch {r c} {
	upvar #0 $itk_option(-variable) data

	set row	[lindex $itk_option(-rows) $r]
	set col	[lindex $itk_option(-cols) $c]

	if {$r != -1 && $c != -1 && [info exists data($row,$col)]} {
		return $data($row,$col)
	} elseif {$r != -1 && $c == -1} {
		return $row
	} elseif {$r == -1 && $c != -1} {
		return $col
	} else {
		return ""
	}
}
body tk++::Sheet::_reconfig {} {
	$itk_component(table) conf \
		-usecommand 1 \
		-rows [expr [llength $itk_option(-rows)] + 1] \
		-cols [expr [llength $itk_option(-cols)] + 1]
	$itk_component(table) flush
}
