#
# Sensus Consulting Ltd, Copyright 1997-1998
#
# Matt Newman <matt@sensus.org>
#
#
#
#
package require registry

namespace eval url {}
namespace eval url::registry {}

proc url::registry {option args} {return [eval url::registry::$option $args]}

;proc url::registry::iscontainer {path} {
	if [string match {*/} $path] {
		return 0
	} else {
		return 1
	}
}
;proc url::registry::configure {path} {
	if {$path == ""} {
		return [list -name Registry \
			-container 1 -image [img reg32] \
			-size 0 -mtime 0 -type registry]
	} elseif [string match {*/} $path] {
		set tail [tail $path]
		return [list -name $tail \
			-container 1 -image [img folder] \
			-size 0 -mtime 0 -type registry]
	} else {
		set tail [tail $path]
		if {$tail == ""} {set tail "(default)"}
		return [list -name $tail \
			-container 0 -image [img reg32] \
			-size 0 -mtime 0 -type registry]
	}
}
;proc url::registry::children {path {glob *}} {
	if {$path == "" || [regexp {^//[^/]*$} $path]} {
		catch {registry keys ""} keys
		regsub {^.*be } $keys {} keys
		regsub -all {, } $keys { } keys
		regsub { or} $keys {} keys
		set values {}
	} else {
		regsub {/$} $path {} path
		regsub -all {/} $path {\\} path
		if [catch {registry keys $path $glob} keys] {
			set keys {}
		}
		if [catch {registry values $path $glob} values] {
			set values {}
		}
	}
	set nkeys {}
	foreach key $keys {
		lappend nkeys ${key}/
	}
	return [lsort [concat $nkeys $values]]
}
;proc url::registry::join {path key} {
	return "${path}$key"
}
;proc url::registry::parent {path} {
	if [string match {*/} $path] {
		regsub {[^/]*/$} $path {} path
		return $path
	} else {
		regsub {[^/]*$} $path {} path
		return $path
	}
}
;proc url::registry::split {path} {
	return [::split $path "/"]
}
;proc url::registry::tail {path} {
	if [string match {*/} $path] {
		regsub {^.*[/]([^/]*)/$} $path {\1} path
		return $path
	} else {
		regsub {^.*[/]([^/]*)$} $path {\1} path
		return $path
	}
}
